#include <cstdio>
#include <algorithm>
#include <cmath>
#pragma comment(linker,"/stack:30000000")
#define sqr(x) ((x)*(x))
using namespace std;
const int MaxK = 1000;
int i, j, k, n, m;
int vx[MaxK+1], vy[MaxK+1], xs[MaxK+1], ys[MaxK+1], ls, ans;
int E, U, q[MaxK+1], num[MaxK*MaxK+1][2], p;
double a, b, c, d, t, l, list[MaxK*MaxK+1], t1, t2, r, x;
bool vis[MaxK+1];
FILE *fi, *fo;

void QSort(int l, int r){
  int i = l; int j = r; x = list[l+rand()%(r-l)];
  do{
    while(fabsl(list[i]) < fabsl(x) || ((fabsl(list[i]) == fabsl(x)) && (list[i] < x))) i++;
    while(fabsl(list[j]) > fabsl(x) || ((fabsl(list[j]) == fabsl(x)) && (list[j] > x))) j--;
    if(i<=j){
      swap(list[i], list[j]);
      swap(num[i][0], num[j][0]); swap(num[i][1], num[j][1]);
      i++; j--;
    }
  }while(i<=j);
  if(l < j) QSort(l, j);
  if(i < r) QSort(i, r);

}

int main(){
  ls = 0; srand(31415926); n = 0; ans = 0;
  memset(q, 0, sizeof(q));
  memset(vis, false, sizeof(vis));
  fi = fopen("input.txt", "r");
  fo = fopen("output.txt", "w");
  fscanf(fi, "%i%i%i%lf%lf", &k, &E, &U, &l, &t);
  for(i = 1; i <= k; i++){
    fscanf(fi, "%i%i%i%i", &xs[i], &ys[i], &vx[i], &vy[i]);
  }
  for(i = 1; i <= k-1; i++){
    for(j = i+1; j <= k; j++){
      vis[i] = (sqr(xs[i]-xs[j]) + sqr(ys[i]-ys[j]) <= sqr(l)) || vis[i];
      vis[j] = (sqr(xs[i]-xs[j]) + sqr(ys[i]-ys[j]) <= sqr(l)) || vis[j];
    }
  }
  for(i = 1; i <= k; i++)
    if(vis[i]) ans += E; else ans += U;
  for(i = 1; i <= k-1; i++){
    for(j = i+1; j <= k; j++){
      a = sqr(vx[i]-vx[j]) + sqr(vy[i]-vy[j]);
      b = 2*((xs[i]-xs[j])*(vx[i]-vx[j]) + (ys[i]-ys[j])*(vy[i]-vy[j]));
      c = sqr(xs[i]-xs[j]) + sqr(ys[i]-ys[j]) - sqr(l);
      if (a == 0){
        if(sqr(xs[i]-xs[j]) + sqr(ys[i]-ys[j]) <= sqr(l)){
          if(q[i] == 0) n++; if(q[j] == 0) n++; 
          q[i]++; q[j]++;
          continue;
        }else{
          continue;
        }
      }
      d = sqr(b) - 4*a*c;
      if(d < 0) continue;
      t1 = (-b -sqrt(d))/(2*a); t2 = (-b +sqrt(d))/(2*a);
      if(t1 < 0) t1 = -0; if(t2 < 0) t2 = 0;
      if(sqr(t1) + sqr(t2) == 0) continue;
      if (t1 == 0){
        if(q[i] == 0) n++; if(q[j] == 0) n++; 
        q[i]++; q[j]++;
      }else{
        if(t1 <= t){
          list[++ls] = -t1;
          num[ls][0] = i; num[ls][1] = j;
        }
      }
      if(t2 <= t){
        list[++ls] = t2;
        num[ls][0] = i; num[ls][1] = j;
      }
    }
  }
  if(ls > 1) QSort(1, ls);
  if(ans < E*n + (k-n)*U) ans = E*n + (k-n)*U;
  for(i = 1; i <= ls; i++){
    if(list[i] < 0){
      q[num[i][0]]++; q[num[i][1]]++;
      if(q[num[i][0]] == 1) n++; if(q[num[i][1]] == 1) n++;
    }else{
      q[num[i][0]]--; q[num[i][1]]--;
      if(q[num[i][0]] == 0) n--; if(q[num[i][1]] == 0) n--;
    }
    if(E*n + (k-n)*U > ans) ans = E*n + (k-n)*U;
  }
  fprintf(fo, "%i", ans);
  fclose(fi);
  fclose(fo);
  return 0;
}